*********************************************************
*
*	PROGRAM TO COPY TT: INPUT LINES TO LP:
*
*	PUBLIC DOMAIN PROGRAM BY ROBERT A. LINDLEY
*	4257 BERWICK PLACE, WOODBRIDGE VA 22192
*
.EXIT	EQU	0Q
.SCIN	EQU	1Q
.SCOUT	EQU	2Q
.PRINT	EQU	3Q
.WRITE	EQU	5Q
.CTLC	EQU	41Q
.OPENW	EQU	43Q
.CLOSE	EQU	46Q
.ERROR	EQU	57Q

$TYPTX	EQU	031136A
BELL	EQU	7
NL	EQU	10
ESC	EQU	27
HIBIT	EQU	128

	ORG	042200A

*  OPEN DEVICE FROM COMMAND LINE
BEGIN	LXI	D,FNAME
	LXI	H,0
	DAD	SP
	MOV	A,M
	CPI	40Q
	JNZ	OPENFIL
	INX	H
GETCHR	MOV	A,M
	STAX	D
	CPI	0
	JZ	LPOPN1
	INX	H
	INX	D
	JMP	GETCHR
LPOPN1	INX	D
	MVI	A,200Q
	STAX	D

*  OPEN LP: FOR WRITE
OPENFIL LXI	D,DFBLK
	LXI	H,FNAME
	MVI	A,1
	SCALL	.OPENW

*  TEST FOR OPEN ERROR
	JC	FILEERR

* SIGN ON MESSAGE
	CALL	$TYPTX
	DB	ESC,'E','What you type here'
	DB	' will be printed '
	DB	'line by line on',' '+HIBIT
	LXI	H,FNAME
	SCALL	.PRINT
	CALL	$TYPTX
	DB	NL,'Use CTRL-D to exit to HDOS.',NL,NL+HIBIT

	MVI	A,3	CONTROL C HANDLING
	LXI	H,CCINT
	SCALL	.CTLC

*  LOOP READING AND WRITING CHARACTERS
LOOP	SCALL	.SCIN	CONSOLE INPUT
	JC	LOOP

*  LOOK FOR CTRL-D TO EXIT
	CPI	4
	JZ	XIT
	STA	BUFF
	MVI	A,1
	LXI	B,1A
	LXI	D,BUFF
	SCALL	.WRITE
	JC	FILEERR
	JMP	LOOP

*  CLOSE FILE AND EXIT TO HDOS
CCINT	EQU	*
XIT	MVI	A,1
	SCALL	.CLOSE
	MVI	A,0
	SCALL	.EXIT

*  FILE ERROR EXIT
FILEERR PUSH	PSW	SAVE ERROR CODE
	LXI	H,ERRORA
	SCALL	.PRINT
	POP	PSW
	MVI	H,BELL	BELL WITH MESSAGE
	SCALL	.ERROR
	XRA	A
	SCALL	.EXIT

*  DATA SPACE
ERRORA	DB	NL,'ERROR -',' '+200Q
DFBLK	DB	'SY0',0,0,0
FNAME	DB	'LP:',0,200Q,'SPACE FOR LARGER NAME.'
	DB	HIBIT
DONE	DB	0
BUFF	DB	0
	END	BEGIN
